> ## Documentation Index
> Fetch the complete documentation index at: https://docs.semicola.com/llms.txt
> Use this file to discover all available pages before exploring further.

# RFP actions (REST mirror of save_rfp)



## OpenAPI

````yaml /openapi/storefront.yaml post /api/v2/storefront/rfps
openapi: 3.1.0
info:
  title: Semicola Exchange storefront API
  version: 2.0.0
  description: >-
    Seller (storefront) endpoints: storefront setup, inventory sources,
    products, AI Business Rules, playbook, demand inbox, proposals, approvals
    and seller reporting.
servers:
  - url: https://api.semicola.com
security:
  - bearerAuth: []
  - sessionCookie: []
tags:
  - name: Storefront
  - name: Inventory Sources
  - name: Products
  - name: Business Rules
  - name: Playbook
  - name: Library
  - name: Demand Inbox
  - name: Proposals
  - name: Approvals
  - name: Creative Reviews
  - name: Media Buys
  - name: Buyers
  - name: Reporting
  - name: Activity
  - name: Test Runs
paths:
  /api/v2/storefront/rfps:
    post:
      tags:
        - Demand Inbox
      summary: RFP actions (REST mirror of save_rfp)
      operationId: postStorefrontRfps
      requestBody:
        required: true
        content:
          application/json:
            schema:
              oneOf:
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: create
                    origin:
                      type: string
                      enum:
                        - adcp
                        - manual
                        - imported
                        - starter
                    purpose:
                      type: string
                      enum:
                        - live
                        - evaluation
                        - draft
                    request:
                      type: object
                      properties:
                        brief:
                          type: string
                          minLength: 1
                          maxLength: 20000
                        budget:
                          anyOf:
                            - type: number
                              minimum: 0
                            - type: string
                              pattern: ^\d+(\.\d{1,6})?$
                        currency:
                          type: string
                          pattern: ^[A-Z]{3}$
                        flight:
                          type: object
                          properties:
                            startAt:
                              type: string
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                            endAt:
                              type: string
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                          required:
                            - startAt
                            - endAt
                        channels:
                          type: array
                          items:
                            type: string
                            enum:
                              - display
                              - olv
                              - social
                              - search
                              - ctv
                              - linear_tv
                              - radio
                              - streaming_audio
                              - podcast
                              - dooh
                              - ooh
                              - print
                              - cinema
                              - email
                              - gaming
                              - retail_media
                              - influencer
                              - affiliate
                              - product_placement
                              - sponsored_intelligence
                        formatKinds:
                          type: array
                          items:
                            type: string
                            enum:
                              - image
                              - html5
                              - display_tag
                              - image_carousel
                              - video_hosted
                              - video_vast
                              - audio_hosted
                              - audio_daast
                              - sponsored_placement
                              - native_in_feed
                              - responsive_creative
                              - agent_placement
                              - custom
                        countries:
                          type: array
                          items:
                            type: string
                            pattern: ^[A-Z]{2}$
                        constraints:
                          type: array
                          items:
                            type: string
                        productCount:
                          type: integer
                          exclusiveMinimum: 0
                          maximum: 9007199254740991
                        instruction:
                          type: string
                          maxLength: 4000
                      required:
                        - brief
                      additionalProperties: false
                    strategy:
                      type: object
                      propertyNames:
                        type: string
                      additionalProperties: {}
                    clientRequestId:
                      type: string
                      minLength: 1
                  required:
                    - action
                    - origin
                    - purpose
                    - request
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: append_turn
                    rfpId:
                      type: string
                      minLength: 1
                    parentTurnId:
                      type: string
                      minLength: 1
                    request:
                      type: object
                      properties:
                        brief:
                          type: string
                          minLength: 1
                          maxLength: 20000
                        budget:
                          anyOf:
                            - type: number
                              minimum: 0
                            - type: string
                              pattern: ^\d+(\.\d{1,6})?$
                        currency:
                          type: string
                          pattern: ^[A-Z]{3}$
                        flight:
                          type: object
                          properties:
                            startAt:
                              type: string
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                            endAt:
                              type: string
                              format: date-time
                              pattern: >-
                                ^(?:(?:\d\d[2468][048]|\d\d[13579][26]|\d\d0[48]|[02468][048]00|[13579][26]00)-02-29|\d{4}-(?:(?:0[13578]|1[02])-(?:0[1-9]|[12]\d|3[01])|(?:0[469]|11)-(?:0[1-9]|[12]\d|30)|(?:02)-(?:0[1-9]|1\d|2[0-8])))T(?:(?:[01]\d|2[0-3]):[0-5]\d:[0-5]\d(?:\.\d+)?(?:Z|([+-](?:[01]\d|2[0-3]):[0-5]\d)))$
                          required:
                            - startAt
                            - endAt
                        channels:
                          type: array
                          items:
                            type: string
                            enum:
                              - display
                              - olv
                              - social
                              - search
                              - ctv
                              - linear_tv
                              - radio
                              - streaming_audio
                              - podcast
                              - dooh
                              - ooh
                              - print
                              - cinema
                              - email
                              - gaming
                              - retail_media
                              - influencer
                              - affiliate
                              - product_placement
                              - sponsored_intelligence
                        formatKinds:
                          type: array
                          items:
                            type: string
                            enum:
                              - image
                              - html5
                              - display_tag
                              - image_carousel
                              - video_hosted
                              - video_vast
                              - audio_hosted
                              - audio_daast
                              - sponsored_placement
                              - native_in_feed
                              - responsive_creative
                              - agent_placement
                              - custom
                        countries:
                          type: array
                          items:
                            type: string
                            pattern: ^[A-Z]{2}$
                        constraints:
                          type: array
                          items:
                            type: string
                        productCount:
                          type: integer
                          exclusiveMinimum: 0
                          maximum: 9007199254740991
                        instruction:
                          type: string
                          maxLength: 4000
                      required:
                        - brief
                      additionalProperties: false
                  required:
                    - action
                    - rfpId
                    - parentTurnId
                    - request
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: record_feedback
                    rfpId:
                      type: string
                      minLength: 1
                    turnId:
                      type: string
                      minLength: 1
                    grade:
                      type: string
                      enum:
                        - A
                        - B
                        - C
                        - D
                        - E
                        - F
                    ledBy:
                      type: string
                      enum:
                        - agent
                        - human
                    feedback:
                      type: object
                      properties:
                        note:
                          type: string
                          maxLength: 4000
                      required:
                        - note
                      additionalProperties: false
                  required:
                    - action
                    - rfpId
                    - turnId
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: endorse
                    rfpId:
                      type: string
                      minLength: 1
                    commentary:
                      type: string
                      maxLength: 4000
                  required:
                    - action
                    - rfpId
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: unendorse
                    rfpId:
                      type: string
                      minLength: 1
                  required:
                    - action
                    - rfpId
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: attach_response
                    rfpId:
                      type: string
                      minLength: 1
                    materialId:
                      type: string
                      minLength: 1
                  required:
                    - action
                    - rfpId
                    - materialId
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: request_representation
                    rfpId:
                      type: string
                      minLength: 1
                    turnId:
                      type: string
                      minLength: 1
                    representation:
                      type: object
                      properties:
                        format:
                          type: string
                          enum:
                            - seller_response_json
                            - html
                            - pdf
                            - pptx
                        audience:
                          type: string
                          enum:
                            - seller_preview
                            - buyer_delivery
                      required:
                        - format
                      additionalProperties: false
                  required:
                    - action
                    - rfpId
                    - turnId
                    - representation
                  additionalProperties: false
                - type: object
                  properties:
                    confirm:
                      type: boolean
                    action:
                      type: string
                      const: cancel_representation
                    rfpId:
                      type: string
                      minLength: 1
                    representationId:
                      type: string
                      minLength: 1
                  required:
                    - action
                    - rfpId
                    - representationId
                  additionalProperties: false
      responses:
        '200':
          description: OK
          content:
            application/json:
              schema:
                type: object
                properties:
                  data:
                    anyOf:
                      - type: object
                        properties:
                          action:
                            type: string
                            enum:
                              - create
                              - append_turn
                              - record_feedback
                              - endorse
                              - unendorse
                              - attach_response
                              - request_representation
                              - cancel_representation
                          rfpId:
                            type: string
                          turnId:
                            type:
                              - string
                              - 'null'
                          turnState:
                            anyOf:
                              - type: string
                                enum:
                                  - queued
                                  - processing
                                  - ready
                                  - passed
                                  - needs_clarification
                                  - failed
                              - type: 'null'
                          representationId:
                            type:
                              - string
                              - 'null'
                        required:
                          - action
                          - rfpId
                          - turnId
                          - turnState
                          - representationId
                        additionalProperties: false
                      - type: 'null'
                  error:
                    anyOf:
                      - type: object
                        properties:
                          code:
                            type: string
                          message:
                            type: string
                          field:
                            type: string
                          details: {}
                        required:
                          - code
                          - message
                        additionalProperties: false
                      - type: 'null'
                required:
                  - data
                  - error
                additionalProperties: false
        default:
          description: >-
            Error envelope `{data: null, error: {code, message, field?,
            details?}}`.
components:
  securitySchemes:
    bearerAuth:
      type: http
      scheme: bearer
      description: API key or OAuth access token.
    sessionCookie:
      type: apiKey
      in: cookie
      name: sc_session

````